// Inserts an incremented count before each word in the source text.
//	Set USE_GLOBAL to 0 to make the counter a member of the functor.

#define USE_GLOBAL	0

#include <tchar.h>
#include <stdlib.h>
#include <iostream>
#include <sstream>
#include <boost/regex.hpp>

typedef std::wstring	string_t;
typedef wchar_t			char_t;

#if USE_GLOBAL
static int	nCounter;
#endif

template <class M>
class functor
{
public:
	functor()
	{
		nCounter = 0;
	}

	template <class O>
	O operator()(const M& m, O i)
	{
		_TCHAR	buf[16];

		// Generate the sequence number in brackets:
		O	i2 = i;

		*i2++ = _T('(');
		_itow(++nCounter, buf, 10);

		for (const _TCHAR* pBuf = buf; *pBuf; )
			*i2++ = *pBuf++;

		*i2++ = _T(')');

		// Copy the matched text;
		return m.format(i2, _T("$0"));
	}

private:
#if ! USE_GLOBAL
	int	nCounter;
#endif
};

int _tmain(int argc, _TCHAR* argv[])
{
	string_t	sText(_T("The quick brown fox jumped over the lazy dog"));
	string_t	sRE(_T("\\w+"));

	boost::regex_constants::match_flag_type	matchFlags =
		boost::regex_constants::match_default;

	boost::basic_regex<char_t> e;

	e.assign(sRE, matchFlags);

	typedef string_t::const_iterator	string_iterator;

	boost::regex_iterator<string_iterator>	reit(sText.begin(), sText.end(), e, matchFlags);
	boost::regex_iterator<string_iterator>	reEnd;

	boost::match_results<string_iterator>	init_m = *reit;
	boost::match_results<string_iterator>	last_m = init_m;
	std::basic_ostringstream<char_t>		stream;
	std::ostream_iterator<char_t, char_t>	streamIter(stream);

	functor<boost::match_results<string_iterator> >	func;

	for ( ; reit != reEnd; ++reit) {
		const boost::match_results<string_iterator>&	m = *reit;

		// copy the source up to this match
		std::copy(m.prefix().first, m.prefix().second, streamIter);

		// replace the matched text
		m.format(streamIter, func);
		last_m = m;
	}

	// copy the remainder of the source string
	std::copy(last_m.suffix().first, last_m.suffix().second, streamIter);

	std::wcout << stream.str() << std::endl;

	return 0;
}
